=begin
(c) TIG 2010
Explodes a Group, BUT unlike built-in .explode method, which puts Exploded 
Entities that are on 'Layer0' onto the Layer of the original Group, this 
keeps all of the Exploded Entities' Layers unchanged.
Usage: explodegroup2layers()
If no argument is given then the current Selection is used and any Groups 
in it are processed.
If an argument is given and it's a Group then that is processed.
e.g. explodegroup2layers(group)
If an argument is given and it's an Array then any Groups in that Array are 
processed.
e.g. explodegroup2layers([group1,group2,group3])
Probably most useful inside other tools to keep exploded entities on the expected layers.
=end
require 'sketchup.rb'
def explodegroup2layers(g=nil)
  model=Sketchup.active_model
  if g
    groups=[]
    groups=[g] if g.class==Sketchup::Group
    g.each{|e|groups << e if e.class==Sketchup::Group} if g.class==Array
  else
    ents=model.active_entities
    ss=model.selection
    groups=[]
    ss.each{|e|groups << e if e.class==Sketchup::Group}
  end#if
  return nil if not groups
  ###
  model.start_operation("Explode Group to Layers")
  groups.each{|gp|
    gp.make_unique if gp.entities.parent.instances[1]
    gplayers=[]
    gp.entities.each{|e|gplayers << [e, e.layer]}
    gp.explode
    gplayers.each{|a|a[0].layer=a[1]}
  }
  model.commit_operation
  ###
end
###
